// Copyright (c) 2003 Charles Samuels <charles@kde.org>
// See the file COPYING for redistribution terms.
#ifndef BASE_H
#define BASE_H

// ;)
#define unless(e) if(!(e))

#include <qstring.h>
#include <qobject.h>

#include "file.h"

class File;

class Base : public QObject
{
Q_OBJECT

	struct Private;
	Private *d; // not for BC, but for compile times :)

public:
	Base(const QString &file);
	~Base();

	File add(const QString &file);

	File find(FileId id);

	void clear();

	/**
	 * get the highest FileID
	 **/
	FileId high() const;

	QString property(FileId id, const QString &property) const;
	void setProperty(FileId id, const QString &key, const QString &value);

	/**
	 * same as File::remove
	 **/
	void remove(File f);

signals:
	void added(File file);
	void removed(File file);

private:
	void loadIntoCache(FileId id) const;
};


#endif
